%classify_image.m
%ERD
%Modified by EAC

temp=findobj('tag','PopupMenu1');
value=get(temp, 'Value');           

num_of_classes=length(train_data);

if reduced == 0
   bandpixels=pixels;
end

disp('Classifying Image...')

%=============================================================
% Maximum Likelihood
%=============================================================

if value == 1  
   
temp=zeros(1,num_of_classes);
classified_image=zeros(1,length(bandpixels));

for i=1:length(bandpixels)
   for k=1:num_of_classes
      temp(k)=maxlike(bandpixels(:,i),means{k}',covs{k});
   end
      [v,classified_image(i)]=max(temp);
end
classified_image=reshape(classified_image,number_of_columns, number_of_rows)';

figure
colormap(jet(max(max(classified_image))))
image(classified_image)
title('Image classified using Maximum Likelihood')
axes('position',[.93, .25, .05, .50])
colormap(jet(max(max(classified_image))))
image((1:num_of_classes)')

disp('Finished Clasifying...')


%=============================================================
% Euclidean Distance
%=============================================================

elseif value == 2  
     
temp=zeros(1,num_of_classes);
classified_image=zeros(1,length(bandpixels));

for i=1:length(bandpixels)
   for k=1:num_of_classes
      temp(k)=euclid(bandpixels(:,i),means{k}');
   end
      [v,classified_image(i)]=max(temp);
end
classified_image=reshape(classified_image,number_of_columns, number_of_rows)';

figure
colormap(jet(max(max(classified_image))))
image(classified_image)
title('Image classified using Euclidean Distance')
axes('position',[.93, .25, .05, .50])
colormap(jet(max(max(classified_image))))
image((1:num_of_classes)')

disp('Finished Clasifying...')


%=============================================================
% Angle Detection
%=============================================================

elseif value == 3  
   
temp=zeros(1,num_of_classes);
classified_image=zeros(1,length(bandpixels));

for i=1:length(bandpixels)
   for k=1:num_of_classes
      temp(k)=angledet(bandpixels(:,i),means{k}');
   end
      [v,classified_image(i)]=min(temp);
end
classified_image=reshape(classified_image,number_of_columns, number_of_rows)';

figure
colormap(jet(max(max(classified_image))))
image(classified_image)
title('Image classified using Angle Detection')
axes('position',[.93, .25, .05, .50])
colormap(jet(max(max(classified_image))))
image((1:num_of_classes)')

disp('Finished Clasifying...')


end

clear i j k v temp s_cov a_cov maxi fish euc mah tag_maxi tag_fish tag_euc tag_mah
clear num_of_classes value             
