% classify_samples.m
% ERD
%modified 2/21/01 EAC

temp=findobj('tag','PopupMenu1');
value=get(temp, 'Value');           

num_of_classes=length(train_data);

disp('Classifying Training Samples...')

%=============================================================
% Maximum Likelihood
%=============================================================

if value == 1
   
temp=zeros(1,num_of_classes);
error=zeros(1,num_of_classes);

for j=1:num_of_classes
   e=0;

   for i=1:length(train_data{j})
      g=train_data{j};
      
      for k=1:num_of_classes
         temp(k)=maxlike(g(:,i),means{k}',covs{k});
      end
      
      if temp(j)==max(temp)
      e=e+1;
      end
      
   end
   error(j)=e;

end

etotal=0;
stotal=0;

disp('For Maximum Likelihood Classifier...')
disp(' ')

for i=1:num_of_classes
   disp(sprintf('The accuracy of the Training Samples of Class %d is %.4f%%. \n', i, error(i)/length(train_data{i})*100))
   etotal=etotal + error(i);
   stotal=stotal + length(train_data{i});
end

disp(sprintf('The accuracy of the total Training Samples is %.4f%%. \n', etotal/stotal*100))



%=============================================================
% Euclidean Distance
%=============================================================

elseif value == 2
   
temp=zeros(1,num_of_classes);
error=zeros(1,num_of_classes);

for j=1:num_of_classes
   e=0;

   for i=1:length(train_data{j})
      g=train_data{j};
      
      for k=1:num_of_classes
         temp(k)=euclid(g(:,i),means{k}');
      end
      
      if temp(j)==max(temp)
      e=e+1;
      end
      
   end
   error(j)=e;

end

etotal=0;
stotal=0;

disp('For Euclidean Distance Classifier...')
disp(' ')

for i=1:num_of_classes
   disp(sprintf('The accuracy of the Training Samples of Class %d is %.4f%%. \n', i, error(i)/length(train_data{i})*100))
   etotal=etotal + error(i);
   stotal=stotal + length(train_data{i});
end

disp(sprintf('The accuracy of the total Training Samples is %.4f%%. \n', etotal/stotal*100))


%=====================================================================
% Angle Detection
%=====================================================================

elseif value == 3

temp=zeros(1,num_of_classes);
error=zeros(1,num_of_classes);

for j=1:num_of_classes
   e=0;

   for i=1:length(train_data{j})
      g=train_data{j};
      
      for k=1:num_of_classes
         temp(k)=angledet(g(:,i),means{k}');
      end
      
      if temp(j)==min(temp)
      e=e+1;
      end
      
   end
   error(j)=e;

end

etotal=0;
stotal=0;

disp('For Angle Detection ...')
disp(' ')

for i=1:num_of_classes
   disp(sprintf('The accuracy of the Training Samples of Class %d is %.4f%%. \n', i, error(i)/length(train_data{i})*100))
   etotal=etotal + error(i);
   stotal=stotal + length(train_data{i});
end

disp(sprintf('The accuracy of the total Training Samples is %.4f%%. \n', etotal/stotal*100))


end

clear i j k n etotal e stotal a_cov g s_cov temp error maxi fish euc mah 
clear tag_maxi tag_fish tag_euc tag_mah value 
